"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function astTransformationToJSCodeshiftModule(transformAST) {
    const transform = (file, api, options) => {
        const j = api.jscodeshift;
        let root;
        try {
            root = j(file.source);
        }
        catch (err) {
            console.error(`JSCodeshift failed to parse ${file.path},` +
                ` please check whether the syntax is valid`);
            return;
        }
        transformAST({ root, j, filename: file.path }, options);
        return root.toSource({ lineTerminator: '\n' });
    };
    return transform;
}
exports.default = astTransformationToJSCodeshiftModule;
