"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.transformAST = void 0;
const OperationUtils = __importStar(require("../src/operationUtils"));
const parser = __importStar(require("vue-eslint-parser"));
const wrapVueTransformation_1 = __importDefault(require("../src/wrapVueTransformation"));
const transformAST = context => {
    let fixOperations = [];
    const toFixNodes = findNodes(context);
    const { file } = context;
    const source = file.source;
    toFixNodes.forEach(node => {
        fixOperations = fixOperations.concat(fix(node, source));
    });
    return fixOperations;
};
exports.transformAST = transformAST;
exports.default = wrapVueTransformation_1.default(exports.transformAST);
function findNodes(context) {
    const { file } = context;
    const source = file.source;
    const options = { sourceType: 'module' };
    const ast = parser.parse(source, options);
    let toFixNodes = [];
    let root = ast.templateBody;
    // find router-link nodes
    parser.AST.traverseNodes(root, {
        enterNode(node) {
            if (node.type === 'VElement' && node.name === 'router-link') {
                toFixNodes.push(node);
            }
        },
        leaveNode(node) { }
    });
    return toFixNodes;
}
function fix(node, source) {
    node = node;
    let fixOperations = [];
    // get tag attribute and event attribute value
    // get other attribute text
    let tagValue, eventValue;
    let attrText = '';
    node.startTag.attributes.forEach(attr => {
        var _a, _b;
        if (attr.type === 'VAttribute') {
            const name = attr.key.name;
            if (name === 'tag' && ((_a = attr.value) === null || _a === void 0 ? void 0 : _a.type) === 'VLiteral') {
                tagValue = attr.value.value;
            }
            else if (name === 'event' && ((_b = attr.value) === null || _b === void 0 ? void 0 : _b.type) === 'VLiteral') {
                eventValue = attr.value.value;
            }
            else {
                attrText += OperationUtils.getText(attr, source);
            }
        }
    });
    if (tagValue || eventValue) {
        // convert event attribute to new syntax
        eventValue = eventValue || ['click'];
        if (typeof eventValue === 'string') {
            if (eventValue.includes(',')) {
                eventValue = JSON.parse(eventValue.replace(/'/g, '"'));
            }
            else {
                eventValue = [eventValue];
            }
        }
        const event = eventValue
            .map((value) => `@${value}="navigate"`)
            .join(' ');
        // get tag attribute value and router-link text
        tagValue = tagValue || 'a';
        const text = OperationUtils.getText(node.children[0], source);
        // convert to new syntax
        fixOperations.push(OperationUtils.replaceText(node.startTag, `<router-link ${attrText} custom v-slot="{ navigate }">`));
        fixOperations.push(OperationUtils.remove(node.children[0]));
        fixOperations.push(OperationUtils.insertTextAfter(node.startTag, `<${tagValue} ${event}>${text}</${tagValue}>`));
    }
    return fixOperations;
}
