"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.transformAST = void 0;
const OperationUtils = __importStar(require("../src/operationUtils"));
const parser = __importStar(require("vue-eslint-parser"));
const wrapVueTransformation_1 = __importDefault(require("../src/wrapVueTransformation"));
const transformAST = context => {
    let fixOperations = [];
    const { file } = context;
    const source = file.source;
    const toFixNodes = findNodes(context);
    toFixNodes.forEach(node => {
        fixOperations = fixOperations.concat(fix(node, source));
    });
    return fixOperations;
};
exports.transformAST = transformAST;
exports.default = wrapVueTransformation_1.default(exports.transformAST);
function findNodes(context) {
    const { file } = context;
    const source = file.source;
    const options = { sourceType: 'module' };
    const ast = parser.parse(source, options);
    let toFixNodes = [];
    let root = ast.templateBody;
    // find transition nodes
    parser.AST.traverseNodes(root, {
        enterNode(node) {
            if (node.type === 'VElement' &&
                node.name === 'transition' &&
                node.children.length) {
                toFixNodes.push(node);
            }
        },
        leaveNode(node) { }
    });
    return toFixNodes;
}
function fix(node, source) {
    let fixOperations = [];
    // find transition nodes which contain router-view node.
    // note that router-view tag may under the keep-alive tag
    let routerView;
    const children = node.children;
    const keepAlive = children.find(child => {
        return (child.type === 'VElement' &&
            child.name === 'keep-alive' &&
            child.children.length);
    });
    if (keepAlive) {
        routerView = keepAlive.children.find(child => {
            return child.type === 'VElement' && child.name === 'router-view';
        });
    }
    else {
        routerView = node.children.find(child => {
            return child.type === 'VElement' && child.name === 'router-view';
        });
    }
    // replace with vue-router-next syntax
    if (routerView) {
        routerView = routerView;
        // get attributes text
        let attributeText = '';
        routerView.startTag.attributes.forEach(node => (attributeText += OperationUtils.getText(node, source)));
        // replace with vue-router-next syntax
        fixOperations.push(OperationUtils.replaceText(routerView, '<component :is="Component" />'));
        fixOperations.push(OperationUtils.insertTextBefore(node, `<router-view ${attributeText} v-slot="{ Component }">`));
        fixOperations.push(OperationUtils.insertTextAfter(node, '</router-view>'));
    }
    return fixOperations;
}
