"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.transformAST = void 0;
const OperationUtils = __importStar(require("../src/operationUtils"));
const parser = __importStar(require("vue-eslint-parser"));
const wrapVueTransformation_1 = __importDefault(require("../src/wrapVueTransformation"));
const transformAST = context => {
    let fixOperations = [];
    const toFixNodes = findNodes(context);
    toFixNodes.forEach(node => {
        fixOperations = fixOperations.concat(fix(node));
    });
    return fixOperations;
};
exports.transformAST = transformAST;
exports.default = wrapVueTransformation_1.default(exports.transformAST);
function findNodes(context) {
    const { file } = context;
    const source = file.source;
    const options = { sourceType: 'module' };
    const ast = parser.parse(source, options);
    let toFixNodes = [];
    let root = ast.templateBody;
    parser.AST.traverseNodes(root, {
        enterNode(node) {
            var _a, _b;
            if (node.type === 'VAttribute' &&
                node.key.type === 'VDirectiveKey' &&
                node.key.name.name === 'slot' &&
                ((_a = node.key.argument) === null || _a === void 0 ? void 0 : _a.type) === 'VIdentifier' &&
                ((_b = node.key.argument) === null || _b === void 0 ? void 0 : _b.name) === 'default' &&
                node.parent.parent.type == 'VElement' &&
                node.parent.parent.name == 'template') {
                toFixNodes.push(node);
            }
        },
        leaveNode(node) { }
    });
    return toFixNodes;
}
function fix(node) {
    let fixOperations = [];
    const target = node.parent.parent;
    const targetParent = target.parent;
    targetParent.children
        .filter((el) => el.type == 'VElement' && el.name != 'template')
        .forEach((element) => {
        fixOperations.push(OperationUtils.remove(element));
    });
    return fixOperations;
}
