"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.transformAST = void 0;
const OperationUtils = __importStar(require("../src/operationUtils"));
const parser = __importStar(require("vue-eslint-parser"));
const wrapVueTransformation_1 = __importDefault(require("../src/wrapVueTransformation"));
const transformAST = context => {
    let fixOperations = [];
    const { file } = context;
    const source = file.source;
    const toFixNodes = findNodes(source);
    toFixNodes.forEach(node => {
        fixOperations = fixOperations.concat(fix(node, source));
    });
    return fixOperations;
};
exports.transformAST = transformAST;
exports.default = wrapVueTransformation_1.default(exports.transformAST);
function findNodes(source) {
    const options = { sourceType: 'module' };
    const ast = parser.parse(source, options);
    let toFixNodes = [];
    let root = ast.templateBody;
    parser.AST.traverseNodes(root, {
        enterNode(node) {
            if (node.type === 'VAttribute' &&
                node.directive &&
                node.key.name.name === 'bind' &&
                node.parent.attributes.length > 1) {
                toFixNodes.push(node);
            }
        },
        leaveNode(node) { }
    });
    return toFixNodes;
}
function fix(node, source) {
    let fixOperations = [];
    // get parent node
    const target = node.parent;
    // get the value of v-bind according to the range
    const bindValue = source.slice(node.range[0], node.range[1]) + ' ';
    // remove node
    if (target.attributes[target.attributes.length - 1] === node) {
        fixOperations.push(OperationUtils.remove(node));
    }
    else {
        fixOperations.push(OperationUtils.removeRange([node.range[0], node.range[1] + 1]));
    }
    // add node to the first
    fixOperations.push(OperationUtils.insertTextBefore(target.attributes[0], bindValue));
    return fixOperations;
}
