"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.transformAST = void 0;
const OperationUtils = __importStar(require("../src/operationUtils"));
const parser = __importStar(require("vue-eslint-parser"));
const wrapVueTransformation_1 = __importDefault(require("../src/wrapVueTransformation"));
const transformAST = context => {
    let fixOperations = [];
    const { file } = context;
    const source = file.source;
    const toFixNodes = findNodes(source);
    toFixNodes.forEach(node => {
        fixOperations = fixOperations.concat(fix(node, source));
    });
    return fixOperations;
};
exports.transformAST = transformAST;
exports.default = wrapVueTransformation_1.default(exports.transformAST);
function findNodes(source) {
    const options = { sourceType: 'module' };
    const ast = parser.parse(source, options);
    let toFixNodes = [];
    let root = ast.templateBody;
    parser.AST.traverseNodes(root, {
        enterNode(node) {
            var _a, _b;
            if (node.type === 'VAttribute' &&
                node.directive &&
                node.key.name.name === 'for' &&
                node.parent.attributes.length > 1) {
                for (let ifNode of node.parent.attributes) {
                    // @ts-ignore
                    if (((_b = (_a = ifNode === null || ifNode === void 0 ? void 0 : ifNode.key) === null || _a === void 0 ? void 0 : _a.name) === null || _b === void 0 ? void 0 : _b.name) === 'if')
                        toFixNodes.push(node);
                }
            }
        },
        leaveNode(node) { }
    });
    return toFixNodes;
}
function fix(node, source) {
    var _a, _b;
    let fixOperations = [];
    const target = node.parent;
    let forValue = source.slice(node.range[0], node.range[1]);
    let keyNode = false;
    for (let findKeyNode of target === null || target === void 0 ? void 0 : target.attributes) {
        // @ts-ignore
        if (((_b = (_a = findKeyNode === null || findKeyNode === void 0 ? void 0 : findKeyNode.key) === null || _a === void 0 ? void 0 : _a.argument) === null || _b === void 0 ? void 0 : _b.name) === 'key')
            keyNode = findKeyNode;
    }
    if (keyNode) {
        let keyValue = source.slice(keyNode.range[0], keyNode.range[1]);
        forValue += ' ' + keyValue;
        fixOperations.push(OperationUtils.remove(keyNode));
    }
    fixOperations.push(OperationUtils.remove(node));
    fixOperations.push(OperationUtils.insertTextBefore(target.parent, `<template ${forValue}>\n`));
    fixOperations.push(OperationUtils.insertTextAfter(target.parent, `\n</template>`));
    return fixOperations;
}
